<?php
/*
Plugin Name: Marmoset Viewer
Plugin URI: http://www.revolutionart.nl/mvwpplugin/
Description: Allows you to embed Marmoset Toolbag2 mview files, allowing people to view your models in all their glory
Version: 1.7.3
Author: Revolutionart
Author URI: revolutionart.nl
*/

// v1.7.3 : Updated help in general settings.
// v1.7.2 : jQuery Lib now used HTTPS instead of HTTP
// v1.7.1 : Minor fix for iOS Devices
// v1.7 : Minor fixes + Redesign settings page and file modal.
// v1.6 : Adds embed system, previous system had serious flaws.
// v1.5 : Removes the iFrame system, adds html to output the viewer.
// v1.4 : Skipped.
// v1.3 : Cleaned up code and added a new feature.
// v1.2 : Changed get_settings to get_option
// v1.1 : Fixed core issues
// v1.0 : First release

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

// Create shortcode for marmoset viewer
// [marmoset id=""]
	function addmarmoset($atts, $content = null) {
		extract(shortcode_atts(array( "id" => '',
									"autostart" => get_option('marmoset-autostart'),
									"transparantbg" => get_option('marmoset-transparantbg'),
									"width" => get_option('marmoset-width'),
									"height" => get_option('marmoset-height'),
							  ), $atts)); 

		return '<iframe frameborder="0" height="'.$height.'" width="'.$width.'" webkitallowfullscreen="true" mozallowfullscreen="true" allowfullscreen="true" src="'.plugins_url( '/mviewer.php?width='.$width.'&height='.$height.'&autostart='.$autostart.'&transparantbg='.$transparantbg.'&id='.$id.'', __FILE__ ) . '"></iframe>';
	}
	add_shortcode('marmoset', 'addmarmoset');

 
// Create marmoset TinyMCE button
	function add_marmoset_button() {
		if( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
		  return;

		if( get_user_option('rich_editing') == 'true') {
		  add_filter('mce_external_plugins', 'add_marmoset_tinymce_plugin');
		  add_filter('mce_buttons', 'register_marmoset_button');
		 }
	}
	
	add_action('init', 'add_marmoset_button');
	
	function register_marmoset_button($buttons) {
		array_push($buttons, "|", "marmosetEmbed");
		return $buttons;
	}

	function add_marmoset_tinymce_plugin($plugin_array) {
		$plugin_array['marmosetEmbed'] = plugins_url( '/custom/editor_plugin.js' , __FILE__ );
		return $plugin_array;
	}

// Add file extension 'mview' with mime type 'application/marmoset-web-viewer'
	function custom_mview_mime_type ( $existing_mimes=array() ) {
			$existing_mimes['mview'] = 'application/marmoset-web-viewer';
			return $existing_mimes;
		}
	add_filter('upload_mimes', 'custom_mview_mime_type');

// Create global settings menu button in Wordpress Dashboard
	if ( is_admin() ){ // admin actions
		add_action( 'admin_menu', 'marmoset_create_menu' );
	}

	function marmoset_create_menu() {
    // Add button to menu name + icon
		add_menu_page('marmoset Plugin Settings', 'Marmoset Viewer', 'administrator',
		__FILE__, 'marmoset_settings_page', plugins_url('/img/marmoset-16x16-menu-icon.svg', __FILE__));
  
    // Register settings
		add_action( 'admin_init', 'register_marmoset_settings' );
	}
	// Register marmoset settings
	function register_marmoset_settings() {
		register_setting( 'settings-group', 'marmoset-width' );
		register_setting( 'settings-group', 'marmoset-height' );
		register_setting( 'settings-group', 'marmoset-autostart' );
		register_setting( 'settings-group', 'marmoset-transparantbg' );
	}

  // Settings page
	function marmoset_settings_page() {
?>
	<style>
		.help-block {
			color: #737373;
			display: block !important;
			margin-bottom: 10px;
			margin-top: 5px;
		}
		.plugin-info {
			border-radius: 4px;
			overflow: hidden;
			position: absolute;
			right: 25px;
			top: 25px;
			width: 300px;
		}		
		.plugin-info .plugin-info-version {
			color: #fff;
			font-size: 16px;
			font-weight: bold;
			position: absolute;
			right: 10px;
			text-transform: uppercase;
			top: 157px;
		}
		.plugin-info figure {
			border-radius: 4px;
			-webkit-box-shadow: 0 2px 2px 0 rgba(0, 0, 0, 0.14), 0 3px 1px -2px rgba(0, 0, 0, 0.2), 0 1px 5px 0 rgba(0, 0, 0, 0.12);
				    box-shadow: 0 2px 2px 0 rgba(0, 0, 0, 0.14), 0 3px 1px -2px rgba(0, 0, 0, 0.2), 0 1px 5px 0 rgba(0, 0, 0, 0.12);
			height: 187px;
			margin: 0 0 15px;
			overflow: hidden;
			top: 0;
			width: 100%;
		}
		.plugin-info figure.author-logo {
			height: 299px;
		}	
		.plugin-info figure img {
			width: 100%;
		}
		
		.plugin-info > ul > header {
			font-weight: bold;
			margin-bottom: 10px;
			text-transform: uppercase;
		}
		.plugin-info > ul > li span {
			font-weight: bold;
		}
		.plugin-info > ul > li {
			font-size: 11px;
		}
		
		.table-mviewer-options tr {
			border-bottom: 1px solid #ddd;
			display: block;
			width: 100%;
		}
		.table-mviewer-options {
			background: #fff none repeat scroll 0 0;
			border-radius: 4px !important;
			box-shadow: 0 2px 2px 0 rgba(0, 0, 0, 0.14), 0 3px 1px -2px rgba(0, 0, 0, 0.2), 0 1px 5px 0 rgba(0, 0, 0, 0.12);
			display: block;
			width: 40%;
		}
		.table-mviewer-options tr th {
			background: #f7f7f7 none repeat scroll 0 0;
			padding-left: 15px;
		}
		.table-mviewer-options td .help-block {
			font-size: 12px;
			font-weight: bold;
		}
		.table-mviewer-options tr:last-child {
			border: medium none;
		}
		.table-mviewer-options tbody {
			display: block;
			width: 100% !important;
		}
	</style>
	<div class="wrap">
		<div class="plugin-info">
			<span class="plugin-info-version">version 1.7.3</span>
			<figure class="plugin-thumb"><img src="<?php echo plugin_dir_url( __FILE__ ) . 'img/marmoset_viewer_thumb.jpg'; ?>"></figure>
			<figure class="author-logo"><a href="http://www.revolutionart.nl/" target="blank"><img src="<?php echo plugin_dir_url( __FILE__ ) . 'img/revolutionart_logo.png'; ?>"></a></figure>
		</div>
		<h2>Marmoset Web Viewer</h2>

		<form method="post" action="options.php">
		<?php settings_fields( 'settings-group' ); ?>

		<h3>Default settings</h3>
			<table class="form-table table-mviewer-options">
			  <tr valign="top">
				<th scope="row">Width</th>
				<td>
					<input type="text" name="marmoset-width" placeholder="100px" value="<?php echo get_option('marmoset-width'); ?>" />
					<p class="help-block">Use px or % Example:  "100%" or "100px" Without Quotes</p>
				</td>
			  </tr>
			  <tr valign="top">
				<th scope="row">Height</th>
				<td>
					<input type="text" name="marmoset-height" placeholder="100px" value="<?php echo get_option('marmoset-height'); ?>" />
					<p class="help-block">Use px or % Example:  "100%" or "100px" Without Quotes</p>
				</td>
				
			  </tr>
			  <tr valign="top">
				<th scope="row">Autostart</th>
				<td>
					<input type="checkbox" name="marmoset-autostart" value="1" <?php checked(get_option('marmoset-autostart'), 1); ?>/>
					<p class="help-block">Check this if you want the viewer to automatically start.</p>
				</td>
			  </tr>
			  <tr valign="top">
				<th scope="row">Transparant Background</th>
				<td>
					<input type="checkbox" name="marmoset-transparantbg" value="1" <?php checked(get_option('marmoset-transparantbg'), 1); ?>/>
					<p class="help-block">Check this if you want the viewer to have a transparant background.</p>
				</td>
			  </tr>
			</table>
		<?php submit_button(); ?>
		</form> 
	</div>

<?php } ?>